/*
 * application.c
 *
 * Copyright 2021 Jonathan Schöbel <jonathan@xn--schbel-yxa.info>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301, USA.
 *
 *
 */

#include <stdlib.h>
#include <gtk/gtk.h>

#include "application.h"


SP_Application * SP_Application_new ()
{
	static SP_Application * Application;
	Application = malloc (sizeof (SP_Application));

	Application->app = gtk_application_new (APPLICATION_ID, G_APPLICATION_FLAGS_NONE);

	g_signal_connect (Application->app, "startup", G_CALLBACK (startup), Application);
	g_signal_connect (Application->app, "activate", G_CALLBACK (activate), Application);

	return Application;
};

static void startup (GtkApplication * app, SP_Application * Application)
{
	Application->Window = SP_Window_new(Application->app);
	gtk_application_add_window (Application->app, Application->Window->window);
	return;
};

static void activate (GtkApplication * app, SP_Application * Application)
{
	SP_Window_activate (Application->Window);
	return;
};

int SP_Application_run (SP_Application * Application, int argc, char **argv)
{
	return g_application_run (G_APPLICATION (Application->app), argc, argv);
};

void SP_Application_free (SP_Application * Application)
{
	g_object_unref (Application->app);
	free (Application);
	return;
};
